//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DAF01370360.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DAF01370360.cm

//## begin module%3DAF01370360.cp preserve=no
//## end module%3DAF01370360.cp

//## Module: PlotRatio%3DAF01370360; Package specification
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotRatio.h

#ifndef PLOTRATIO_H
#define PLOTRATIO_H 1

//## begin module%3DAF01370360.additionalIncludes preserve=no
//## end module%3DAF01370360.additionalIncludes

//## begin module%3DAF01370360.includes preserve=yes
//## end module%3DAF01370360.includes

// PlotCommand
#include <XSPlot/Plot/PlotCommand.h>
//## begin module%3DAF01370360.declarations preserve=no
//## end module%3DAF01370360.declarations

//## begin module%3DAF01370360.additionalDeclarations preserve=yes
class PlotGroup;
class PlotSettings;
struct StandardLabels;
//## end module%3DAF01370360.additionalDeclarations


//## begin PlotRatio%3DAEFC6300E1.preface preserve=yes
//## end PlotRatio%3DAEFC6300E1.preface

//## Class: PlotRatio%3DAEFC6300E1
//## Category: XSPlot::PlotCommands%3DAF12C70234
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class PlotRatio : public PlotCommand  //## Inherits: <unnamed>%4B295A0E0331
{
  //## begin PlotRatio%3DAEFC6300E1.initialDeclarations preserve=yes
  //## end PlotRatio%3DAEFC6300E1.initialDeclarations

  public:
    //## Constructors (generated)
      PlotRatio();

    //## Destructor (generated)
      virtual ~PlotRatio();


    //## Other Operations (specified)
      //## Operation: makeLabels%4B295B6B027E
      //	If not overridden, this does nothing.
      virtual void makeLabels (const PlotSettings& settings, StandardLabels& labels) const;

      //## Operation: makePlotGroups%4B633BF000D6
      //	PlotCommand subclasses will determine whether to create
      //	plot groups from the donated plot group vector (coming
      //	from the previous plot) OR from scratch by calling their
      //	own PlotGroupCreator strategy.  Naturally it will always
      //	do the latter if the donated vector is empty.
      virtual std::vector<PlotGroup*> makePlotGroups (const PlotSettings& settings, const std::vector<const PlotGroup*>& donatedPlotGroups);

    // Additional Public Declarations
      //## begin PlotRatio%3DAEFC6300E1.public preserve=yes
      //## end PlotRatio%3DAEFC6300E1.public

  protected:
    // Additional Protected Declarations
      //## begin PlotRatio%3DAEFC6300E1.protected preserve=yes
      //## end PlotRatio%3DAEFC6300E1.protected

  private:
    //## Constructors (generated)
      PlotRatio(const PlotRatio &right);

    //## Assignment Operation (generated)
      PlotRatio & operator=(const PlotRatio &right);


    //## Other Operations (specified)
      //## Operation: manipulate%4B295B520371
      //	Once the raw data has been gathered into PlotGroup
      //	objects, this is the function that performs the various
      //	mathematical operations specific to each PlotCommand
      //	subclass.
      virtual void manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings);

      //## Operation: setRanges%4B295B580122
      //	Determines plot-time range settings based on current
      //	setplot settings and PlotGroup data.
      virtual void setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings);

    // Additional Private Declarations
      //## begin PlotRatio%3DAEFC6300E1.private preserve=yes
      //## end PlotRatio%3DAEFC6300E1.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin PlotRatio%3DAEFC6300E1.implementation preserve=yes
      //## end PlotRatio%3DAEFC6300E1.implementation

};

//## begin PlotRatio%3DAEFC6300E1.postscript preserve=yes
//## end PlotRatio%3DAEFC6300E1.postscript

// Class PlotRatio 

//## begin module%3DAF01370360.epilog preserve=yes
//## end module%3DAF01370360.epilog


#endif
